% Modifed version of NewtonRoots.m to zoom in on what is happening
% Find roots of polynomial using Newton's method
set(0,'defaultAxesFontSize',18)
set(0,'defaulttextinterpreter','tex') %works everywhere, matlab, octave
%format 'long'
format 'short'

clear all;close all;clc;

c=[':.b'; ':sr'; ':og'; ':pm'; ':.k'; '::hm']; %max of 6 roots

% Poly/Monic coefs
%P=poly(A); %start from eig format (diag matrix A of roots)
P=[1 0 0 0 -1 -1]; %Jarde example of 5th degree monic (5 roots)
R=roots(P); 
Rang = fix(10*angle(R)); %label roots based on their unique angle
Rmag=abs(R);  %label the root magnitude

Pd=polyder(P); Rd=roots(Pd);
sprintf('Roots: %d, %d, %d, %d, %d, %d\n\n',R);
sprintf('Roots: %d, %d, %d, %d, %d, %d\n\n',Rd);

figure(1);
Fp=plot(R,'ob','MarkerSize',10); hold on; grid on;
plot(Rd,'xr','MarkerSize',10);
axis square

y=[]; x=1+eps*j; %complex starting point
  while x~=0;

% Ntrials=input('Number of trials');
Nsteps = 100;
Nsteps = input('steps/per trial=');
alpha = 1;
alpha = input('step size=');

%Now apply Newton method;
%Define starting value
clear xr xi
xr=input('starting value (real)=');
xi=input('starting value (real)=');
%x=(eps+xr)+(eps+xi)*j;
x=xr+ (eps+xi)*j;
 x

%n=1;x(1)=x0+1e-6j;
%x=-3+6*(rand(1))  +3*(rand(1)-.5)*j;
%x=conj(x);

y=[]; %Init to null array
for n=1:Nsteps
y(n)=x; %save sequence
x = x - alpha*polyval(P,x)./polyval(Pd,x);

printf('n=%d, x= (%g,%g)\n\n',n,real(x),imag(x))

%Plot results
plot(x,'o:','MarkerSize',4); hold on; grid on;
%plot(1:length(R),R,'x','MarkerSize',5);hold on
pause(1)
  end %for

  rn=ceil(abs(y(end)));   %must be a positive integer
  plot(y,c(rn,:),'MarkerSize',4); hold on; grid on;
  title('pole-zero plot')
  xlabel('\Re x'); ylabel('\Im x');
  
pause

  %Print out error between final root and precise root
  %identify which root was found
 err=abs(R-y(end));
 Nerr=round(err);
  Nroot=find(Nerr==0);
 dB = round( 20*log10(err(Nroot)) );  %error between converged and actual roots in dB
sprintf('Root %g; Error= %g [dB]',Nroot,dB) %print out error in dB
drawnow;
%input('any key to continue');
%pause
  end %while
