%JBA Jan 3, 2020
%
%NewtonJPD.m: For production: Change the def of roots, and the output file:
%
set(0,'defaultAxesFontSize',18)
%set(0,'defaulttextinterpreter','latex') %Default for matlab

%clear all;
close all;clc;more off;
c=[':.b'; ':sr'; ':og'; ':pm'; ':.k'; ':sc']; %Colors for plotting

%Various root options
%Make two figures for book
R=[1 2 3 4];% JPD suggested this case; filename NewtonJPD
%R=[1+.5j, 2-.5j, 3-1j, 4+1j/2,3+1j];  %filename NewtonJPD2

%R=[1 exp(j*2*pi/3), exp(-j*2*pi/3)]; %3 cube roots of 1; start with 1+j/4
A=diag(R);% matrix with roots on Diag
P=poly(A); %coefs of polynomial
P1=polyder(P); %coefs of derivative of P
R=roots(P); %Recompute R in case of numerical errors
R1=roots(P1);
%sprintf('Roots: %g, %g, %g, %g, %g\n\n',R)
%sprintf('Roots: %g, %g, %g, %g, %g\n\n',R1);

 Coefs=sprintf('$Coefs= [%g, %g, %g, %g]$',P); %save coefs for printing
 Roots=sprintf('$Roots= (%g, %g), (%g, %g), (%g, %g),  (%g, %g) $',...
        real(R(1)),imag(R(1)),real(R(2)),imag(R(2)),real(R(3)),imag(R(3)),real(R(4)),imag(R(4))) ;

 f1=figure(1);
 plot(R,'o','MarkerSize',10); hold on; grid on;
 plot(R1,'x','MarkerSize',10);
 title(Roots, 'fontsize',18);
xlabel('$\Re{y}$'); ylabel('$\Im{y}$');   %Works for matlab but not Octave
xlim([0 5]);ylim([-2 2]);
%xlim([-1.5 1.5]);ylim([-1.5 1.5]);

y=[]; x=1+eps*1j; k=0; kmax=1000; %or 1000 for figs in book
  while k<=kmax %stop after kmax trials
k=k+1;
%clc;

%Now apply Newton method;

%Define starting value
%n=1;x(1)=x0+1e-6j;
x=6*(rand(1))  +3*(rand(1)-.5)*1j; %pick a random starting value

%  x(1)=input('starting value (complex)=');%input a new starting value for each loop

y=[];
  for n=1:10
y(n)=x; %save sequence
x = x - 0.5*polyval(P,x)./polyval(P1,x);
%Plot results
%plot(y,c(rn,:),'MarkerSize',2); hold on; grid on;
%plot(1:length(R),R,'x','MarkerSize',5);hold on

  end %for n=1:10
  rn=round(abs(real(y(end)))); %Bad code: This is used as an index to c(rn). root must have int real part
  if rn < 1 || rn > 5; rn =5;end
	if max(abs(y))<10 %avoid large values
 %       figure(f1);
plot(real(y),imag(y),'.','MarkerSize',10);hold on; grid on;
  plot(real(y),imag(y),c(rn,:),'MarkerSize',4);
%  xlabel('$$\Re{x}$$'); ylabel('$$\Im{x}$$');  %Perhaps for Octave???
  %drawnow;
%  xlim([0 5]);ylim([-2 2]); %limits for figures in book
%  if k==2, input('any key to continue','s'), end
    end  %if max()<5?
%y(1:4) %print out first for steps of itteration
  
%drawnow;%hold off;
%disp(sprintf('y(end)=%g\n',real(y(end))));drawnow;
%pause(.1); %input('Any key to continue');
  end %while k<=kmax
 

%print -depslatex NewtonJPD2.eps

print -dpdf NewtonJPD2  % R=[1+.5j, 2-.5j, 3-1j, 4+1j/2,3+1j]
print -dpdf NewtonJPD   % R=[1 2 3 4]

%pdf is more consistent re fontsize and pdflatex doesnt need to convert eps to pdf;
% requires massive clipping
%print -depsc2 NewtonJPD2; %print -depsc2 NewtonJPD; 

%quit
