
% Working demo of merging the zviz plot with the Newton itteration

% To show the limit cycle start at: s=2 \pm 1.5i; OR s=2+1.4j
% for this starting value, a step size of 0.9 removes the limit cycle
% even stepsize of 0.99 jumps out of the limit cycle after a few steps

clc
close all;
clear all;
fig(18);


%the y and x data values for perfection may depend on labels
%imshow('quartic.png', 'xdata',[-3.3, 3.3], 'ydata',[-2.4, 2.5]'); %y perfect; x is slightly off
%imshow('quartic.png', 'xdata',[-3.5, 3.3], 'ydata',[-2.4, 2.5]'); %x,perfect y close
imshow('quartic.png', 'xdata',[-3.5, 3.3], 'ydata',[-2.4, 2.55]'); %x, y perfect

set(gcf,'defaultAxesFontSize',18)

axis([-2, 2, -2, 2]);  %#1
axis on; grid on; hold on;
Col='--ko'; %starting color

Stepsize=1;
while Stepsize~=0
alpha=input('Stepsize= ');

n=1;
y=[];
s0=input('Starting value=');
s=s0

while n <= 100
  y(n)=s;
  %P = [1 0 0 0 -1 -1] %Coefs of 5th degree poly
L=-(s^5 -s -1)/(5*s^4 -1);
s = s +alpha*L;
disp(sprintf('L=(%g,%g); s=(%g,%g)',real(L),imag(L), real(s),imag(s)));
%input('hit key to continue');
pause(0.1);
plot(real(y)-j*imag(y),Col,'linewidth',2,'markersize',5);
if(abs(L)<1e-6);break;end; %terminate the itteration
n=n+1;
endwhile

s=y(end);
disp('');
disp(sprintf('L=(%g,%g); s=(%g,%g)',real(L),imag(L), real(s),imag(s)));
title(sprintf('StepSize= %g;    n=%d;   S_0= %g+%g i)',alpha,n-1,real(s0),imag(s0)),'fontsize',18);
 %end
%reset color and linetype
Col='--rs';
print -depsc2 'ZvizDemo'
end %while



function [h]=fig(n)
% one time? Do this at top of program:
%   set(0,'defaultAxesFontSize',18)

figure(n);
 set(gcf,'Position',[001+(n-1)*80, 01, 700, 520]);

end

